<!----------------------------------------------------  
Fig Leaf Software
Copyright 2001. All rights reserved. 

HISTORY:
DATE		USER 		ACTION 
07/03/01	shorwith	created
02/11/02   sdrucker     modified to support IE

DESCRIPTION:  Custom tag that creates a pdf from an HTML Stream

Attributes: HTMLStream - the HTML to convert to pdf

EXAMPLE:  

<cfmodule 		template="#request.customtagpath#/pressreleasegeneratepdf.cfm" 
						HTMLStream="#variables.generatedHTML#" 
						PDFName="#variables.pdfname#">
---------------------------------------------------->

<CFPARAM NAME="attributes.renderengine" default="0">
<CFPARAM NAME="attributes.htmlstream" default="">
<CFPARAM NAME="attributes.url" default="">

<CFSCRIPT>

	// initialize the COM objects
	WebGrabber = CreateObject("COM","APWebGrabber.Object");
	Prt2Disk = CreateObject("COM","APServer.Object");
	
	//set the filename
	Prt2Disk.OutputDirectory = attributes.outputdirectory;
	//Prt2Disk.NewDocumentName = attributes.pdfname;
	Prt2DiskSettings = Prt2Disk.ToString();
	
	// use Microsoft Internet Explorer as rendering engine?
	if (attributes.renderengine) {
		WebGrabber.EngineToUse=1;
		WebGrabber.IEWaitBeforePrinting=10;
		WebGrabber.IERightMargin=1.25;
		WebGrabber.IETopMargin=1.25;
		WebGrabber.HTMLTextToFile=true;
	}
	
    WebGrabber.PrintBackGroundColors = 3;
	
	// generate from html stream, or go fetch url directly
	if (attributes.htmlstream is not "") {
		WebGrabber.CreateFromHTMLText = Attributes.HTMLStream;
		WebGrabber.URL = "http://www.anyserver.com";	
	} else {
		WebGrabber.URL = attributes.url;	
	}
	
		
	//  Get the settings from the server
	WebGrabber.Prt2DiskSettings = Prt2DiskSettings;
    
	//Print
	ixi = WebGrabber.DoPrint("127.0.0.1",64320);
 	result = WebGrabber.Wait("127.0.0.1",64320,60,"019");
	
	//newfile = newfile & ".pdf";
	//clean-up
	WebGrabber.CleanUp("127.0.0.1",64320);
</CFSCRIPT>
	
<!--- 
THE Webgrabber.Wait() method will return a value of 19 if the pdf is able to be generated.
I am checking to see whether or not success has been achieved before updating the database with the new file name
 --->
<CFIF result IS "019">
	<CFOUTPUT>
	<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
    <!--
    	alert("PDF Generation Complete")
    //-->
    </SCRIPT>
	</CFOUTPUT>
<CFELSE>
	<CFOUTPUT>#result#</CFOUTPUT>
</CFIF>



